-- lista1.adb
-- Materiały dydaktyczne
-- J.P. 2017

with Ada.Text_IO, Ada.Integer_Text_IO;
use Ada.Text_IO, Ada.Integer_Text_IO;

procedure Lista1 is

type Element is
  record 
    Data : Integer := 0;
    Next : access Element := Null;
  end record;    
  
type Elem_Ptr is access all Element;

procedure Print(List : access Element) is
  L : access Element := List;
begin
  if List = Null then
    Put_Line("List EMPTY!");
    return;
  else
    Put_Line("List:");  
  end if;  
  while L /= Null loop
    Put(">" & L.Data'Img & "#");
    --Put(L.Data, 4); -- z pakietu Ada.Integer_Text_IO
    --New_Line;
    L := L.Next;
  end loop; 
  New_Line;
end Print;  

-- wstawia na początek listy
procedure Insert(List : in out Elem_Ptr; D : in Integer) is
  E : Elem_Ptr := new Element; 
begin
  E.Data := D;
  E.Next := List;
  --lub E.all := (D, List);
  List := E;
end Insert; 

-- wstawianie jako funkcja - wersja krótka
function Insert(List : access Element; D : in Integer) return access Element is 
  ( new Element'(D,List) );  
  
  
-- **********************  
-- do napisania !!  

function Search(List : in Elem_Ptr; D : in Integer) return Boolean is 
begin
  -- napisz funkcję przeszukującą listę, 
  return True;
end Search; 

procedure Insert_Last(List : in out Elem_Ptr; D : in Integer) is 
begin
  -- napisz procedurę wstawiającą element na końcu listy
  null;
end Insert_Last;  

procedure Delete(List : in out Elem_Ptr; D : in Integer) is 
begin
  -- napisz procedurę usuwającą element z listy
  null;
end Delete;      


Lista : Elem_Ptr := Null;

begin
  Print(Lista);
  Lista := Insert(Lista, 21);
  Print(Lista);
  Insert(Lista, 20);  
  Print(Lista);
  for I in reverse 1..12 loop
    Insert(Lista, I);
  end loop;
  Print(Lista);
end Lista1;